
// templates dialog for SuperWebMailer 2023 mirko boeer

tinymce.PluginManager.add('templates', (editor, url) => {

  let language = editor.options.get("language");

  var TemplatesTitle = language == "de" ? HTMLEntityDecode('Vorlage laden') : 'Load template';
  var TemplatesMenuTitle = language == "de" ? HTMLEntityDecode('Vorlage laden...') : 'Load template...';
  var TemplatesLabel = language == "de" ? HTMLEntityDecode('Vorlage w&auml;hlen') : 'Select template';
  var TemplatesPreview = language == "de" ? HTMLEntityDecode('Vorschau der Vorlage') : 'Preview of template';
  var TemplateLoad = language == "de" ? HTMLEntityDecode('Laden') : 'Load';
  var TemplateLoadWarn = language == "de" ? HTMLEntityDecode('Der komplette Inhalt des Editors wird durch die gew&auml;hlte Vorlage ersetzt.') : 'Complete content of editor will be replace with selected template';

  var loadTemplatesDialogAction = function(){

     var date = new Date();
     var nocache = date.getTime() / 1000;

     var url = editor.config.templatesPath + '?IsFCKEditor=true&tinymce=6&ckCsrfToken=' + tinymce.getCsrfToken() + '&nocache=' + nocache;
     var j = DownloadFile(url).trim();
     var templates = [];
     if(j.length > 1 && j[0] == "[" && j[j.length - 1] == "]")
         templates = JSON.parse(j);

     function GetListBoxTemplatesItems(){
       var result = [];
       var count = templates.length;
       for(var i=0; i<count; i++){
         let a = { text: templates[i].title, value: i.toString(), image: templates[i].image  };
         result.push(a);
       }
       return result;
     }


         // https://www.tiny.cloud/docs/tinymce/6/dialog/
         editor.windowManager.open({
                title: TemplatesTitle,
                size: "large",
                body: {
                    type: "panel",
                    items: [

                      {
                        type: 'selectbox', // component type
                        name: 'ListBoxTemplates', // identifier
                        label: TemplatesLabel,
                        enabled: true, // enabled state
                        items: GetListBoxTemplatesItems()
                      },

                      {
                        type: 'iframe', // component type
                        name: 'preview_iframe', // identifier
                        label: TemplatesPreview, // text for the iframe's title attribute
                        sandboxed: true,
                        transparent: true
                      },
                      {
                        type: 'alertbanner', // component type
                        level: 'warn',
                        text: TemplateLoadWarn,
                        icon: 'warn'
                      }

                    ]
                },
                buttons: [{
                    type: "cancel",
                    name: "cancel",
                    text: "Cancel"
                }, {
                    type: "submit",
                    name: "load",
                    text: TemplateLoad,
                    primary: true
                }],
                  initialData: {
                    preview_iframe: templates[0].html
                  },
                  onChange: function(api){

                     const data = api.getData();

                     if( data.ListBoxTemplates >= 0 && data.ListBoxTemplates < templates.length )
                       api.setData({
                         preview_iframe: templates[data.ListBoxTemplates].html
                       })
                       else
                       api.setData({
                         preview_iframe: "<html><head></head><body>Keine Vorlage gefunden / no template found.<body></html>"
                       })
                  },
                  onCancel: function(api){
                  },
                  onSubmit: function(api) {
                    const data = api.getData();

                    if( data.ListBoxTemplates >= 0 && data.ListBoxTemplates < templates.length )
                       editor.setContent( templates[data.ListBoxTemplates].html );

                    api.close();
                }
            })



  }

  editor.ui.registry.addButton('loadtemplatesdialogdialogbutton', {
    icon: "template",
    tooltip: TemplatesTitle,
    onAction: () => {
        loadTemplatesDialogAction();
    }
  });

  editor.ui.registry.addMenuItem('mnuloadtemplatesdialog', {
    text: TemplatesMenuTitle,
    icon: "template",
    onAction: () => {
      loadTemplatesDialogAction();
    }
  });

  return {
    name: 'TemplatesPlugin',
    url: 'https://www.superwebmailer.de/'
  };

});


